package tech.nevets.vplus.items;

import net.minecraft.entity.EquipmentSlot;
import net.minecraft.item.ArmorItem;
import net.minecraft.item.ArmorMaterial;
import net.minecraft.item.Item;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;

public class VPArmor {

    public static final ArmorMaterial COPPER_ARMOR;
    public static final ArmorMaterial EMERALD_ARMOR;
    public static final ArmorMaterial SAPPHIRE_ARMOR;
    public static final ArmorMaterial RUBY_ARMOR;
    public static final ArmorMaterial JADE_ARMOR;

    public VPArmor() {
    }

    static {
        COPPER_ARMOR = register("copper", VPMaterials.COPPER);
        EMERALD_ARMOR = register("emerald", VPMaterials.EMERALD);
        SAPPHIRE_ARMOR = register("sapphire", VPMaterials.SAPPHIRE);
        RUBY_ARMOR = register("ruby", VPMaterials.RUBY);
        JADE_ARMOR = register("jade", VPMaterials.JADE);
    }

    public static VPMaterials register(String id, VPMaterials material) {
        Registry.register(Registry.ITEM, new Identifier("vplus", id + "_helmet"), new ArmorItem(material, EquipmentSlot.HEAD, new Item.Settings().group(VPItemGroups.COMBAT)));
        Registry.register(Registry.ITEM, new Identifier("vplus", id + "_chestplate"), new ArmorItem(material, EquipmentSlot.CHEST, new Item.Settings().group(VPItemGroups.COMBAT)));
        Registry.register(Registry.ITEM, new Identifier("vplus", id + "_leggings"), new ArmorItem(material, EquipmentSlot.LEGS, new Item.Settings().group(VPItemGroups.COMBAT)));
        Registry.register(Registry.ITEM, new Identifier("vplus", id + "_boots"), new ArmorItem(material, EquipmentSlot.FEET, new Item.Settings().group(VPItemGroups.COMBAT)));

        return material;
    }

    public static void init() {}
}
