package tech.nevets.vplus.items;

import net.minecraft.item.Item;
import net.minecraft.item.ToolItem;
import net.minecraft.item.ToolMaterial;
import net.minecraft.util.Identifier;
import net.minecraft.util.registry.Registry;
import tech.nevets.vplus.items.tools.*;

import java.lang.reflect.InvocationTargetException;

public class VPTools {

    public VPTools() {}

    static {
        register(VPMaterials.COPPER);
        register(VPMaterials.EMERALD);
        register(VPMaterials.SAPPHIRE);
        register(VPMaterials.RUBY);
        register(VPMaterials.JADE);
    }

    private static void register(VPMaterials material) {
        Registry.register(Registry.ITEM, new Identifier("vplus", material.getName() + "_axe"), new AxeBase(material, new Item.Settings()));
        Registry.register(Registry.ITEM, new Identifier("vplus", material.getName() + "_hoe"), new HoeBase(material, new Item.Settings()));
        Registry.register(Registry.ITEM, new Identifier("vplus", material.getName() + "_pickaxe"), new PickaxeBase(material, new Item.Settings()));
        Registry.register(Registry.ITEM, new Identifier("vplus", material.getName() + "_shovel"), new ShovelBase(material, new Item.Settings()));
        Registry.register(Registry.ITEM, new Identifier("vplus", material.getName() + "_sword"), new SwordBase(material, new Item.Settings()));
    }

    private static void register(VPMaterials material, Class<? extends ToolItem> T, String toolName) {
        try {
            Registry.register(Registry.ITEM, new Identifier("vplus", material.getName() + "_" + toolName), T.getConstructor(ToolMaterial.class, Item.Settings.class).newInstance(material, new Item.Settings().group(VPItemGroups.TOOLS)));
        } catch (InvocationTargetException | InstantiationException | IllegalAccessException | NoSuchMethodException e) {
            e.printStackTrace();
        }
    }

    private static void registerAll(VPMaterials[] materials, Class<? extends ToolItem> T, String toolName) {
        for (VPMaterials material : materials) {
            try {
                Registry.register(Registry.ITEM, new Identifier("vplus", material.getName() + "_" + toolName), T.getConstructor(ToolMaterial.class, Item.Settings.class).newInstance(material, new Item.Settings().group(VPItemGroups.TOOLS)));
            } catch (InvocationTargetException | InstantiationException | IllegalAccessException | NoSuchMethodException e) {
                e.printStackTrace();
            }
        }
    }

    public static void init() {}
}
